#include <iostream>
#include <vector>

using namespace std;

vector<vector<int>> graph;
vector<int> glb;

int dfs(int v) {
    if (graph[v].size() == 0) {
        return 1;
    }
    for (int i = 0; i < graph[v].size(); ++i) {
        glb[v] = max(glb[v], dfs(graph[v][i]) + 1);
    }
    return glb[v];
}

int main() {
    long long n, m;
    cin >> n >> m;
    graph.assign(n, vector<int>(0));
    glb.assign(n, 0);
    for (int i = 1; i < n; ++i) {
        int parent;
        cin >> parent;
        --parent;
        graph[parent].push_back(i);
    }
    dfs(0);
    long long righth = glb[graph[0][0]];
    long long lefth = 0;
    if (graph[0].size() > 1) {
        lefth = glb[graph[0][1]];
    }
//    cout << righth << ' ' << lefth << endl;
    cout << 2 * m * max(righth, lefth) + lefth + righth << endl;
    return 0;
}
