#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

long long cbrt(long long c) {
    long long l = 0, r = (long long)sqrt(c);
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (m * m * m > c) {
            r = m;
        } else {
            l = m;
        }
    }
    if (l * l * l < c) {
        return r;
    }
    return l;
}

int main() {
    long long a, b, k;
    cin >> a >> b >> k;
    long long start = sqrt(a);
    if (start * start < a) {
        ++start;
    }
    long long finish = (long long)((double)sqrt(b) + 1);
    long long truefinish = sqrt(b);
//    if (finish < start) {
//        cout << 0 << endl;
//        return 0;
//    }
    if (truefinish * truefinish >= b) {
        finish = truefinish;
    }
//    cout << start << ".." << finish << " (" << truefinish << ')' << endl;
    long long ans = 0;
    if (start > finish) {
        cout << 0 << endl;
        return 0;
    }
    for (long long i = start; i < finish; ++i) {
        long long upb = sqrt(i * i * i + k);
        if (upb > truefinish) {
            upb = truefinish;
        }
        double lwsqrt = (double)sqrt(i * i * i - k);
        long long lwb = lwsqrt;
        if (lwb * lwb < i * i * i - k) {
            lwb += 1;
        }
        if (lwb < start) {
            lwb = start;
        }
        if (lwb * lwb > b || lwb < a) {
//            cout << "false lwb = " << lwb << endl;
            lwb = -1;
            upb = -1;
        }
//        cout << "for " << i << ' ' << upb << ' ' << lwb << endl;
        if (lwb != -1) {
            ans += max(upb - lwb + 1, 0ll);
        }
    }
    cout << ans << endl;
    return 0;
}
