#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

long long cbrt(long long c) {
    long long l = 0, r = (long long)sqrt(c);
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (m * m * m > c) {
            r = m;
        } else {
            l = m;
        }
    }
    if (l * l * l < c) {
        return r;
    }
    return l;
}

int main() {
    long long a, b, k;
    cin >> a >> b >> k;
    long long start = sqrt(a);
    long long finish = (long long)((double)sqrt(b) + 1);
    long long ans = 0;
    for (long long i = start; i < finish; ++i) {
        for (long long j = start; j < finish; ++j) {
            if (abs(j * j * j - i * i) <= k && j * j * j <= b && i * i <= b && i * i >= a && j * j * j <= b) {
//                cout << i << ' ' << j << endl;
                ++ans;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
