#include <iostream>

using namespace std;

long long count1n(long long n) {
    return (n * n + n) / 2;
}

long long findmaxc(long long s, long long k) {
    long long l = 1, r = s;
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (count1n(m) > s - m * k) {
            r = m;
        } else {
            l = m;
        }
    }
    return l;
}

int main() {
    long long s;
    long long k;
    cin >> k >> s;
    long long ans = 0;
    long long l = findmaxc(s, 0);
//    cout << l << ' ' << count1n(l) << endl;
    /// s - count1n(l) -  
    long long finas = 0;
    long long prevas = l;
    long long ost = s - count1n(prevas);
    while (ost > 0) {
        finas += ost / prevas;
        ost %= prevas;
        prevas = findmaxc(ost, 0);
    }
    cout << finas + k << endl;
    return 0;
}
