#include <iostream>
#include <vector>

using namespace std;

vector<vector<int>> graph;
vector<int> glb;

int dfs(int v) {
    if (graph[v].size() == 0) {
        glb[v] = 0;
        return 0;
    }
    for (int i = 0; i < graph[v].size(); ++i) {
        glb[v] = max(glb[v], dfs(graph[v][i]) + 1);
    }
    return glb[v];
}

int main() {
    long long n, m;
    cin >> n >> m;
    graph.assign(n, vector<int>(0));
    glb.assign(n, 0);
    for (int i = 1; i < n; ++i) {
        int parent;
        cin >> parent;
        --parent;
        graph[parent].push_back(i);
    }
    dfs(0);
    long long righth = glb[graph[0][0]] + 1;
    long long lefth = 0;
    for (int i = 1; i < graph[0].size(); ++i) {
        if (glb[graph[0][i]] + 1 > righth) {
            lefth = righth;
            righth = glb[graph[0][i]] + 1;
        } else if (glb[graph[0][i]] + 1 > lefth) {
            lefth = glb[graph[0][i]] + 1;
        }
    }
    long long diam = 0;
//    for (int i = 0; i < n; ++i) {
//        cout << glb[i] << ' ';
//    }
//    cout << endl;
    long long diamt = 0;
    for (int i = 0; i < n; ++i) {
        long long lh = 0;
        long long rh = 0;
        long long thisd = 0;
        if (graph[i].size() > 0) {
            rh = glb[graph[i][0]] + 1;
        }
        for (int j = 1; j < graph[i].size(); ++j) {
            if (glb[graph[i][j]] + 1 > rh) {
                lh = rh;
                rh = glb[graph[i][j]] + 1;
            } else if (glb[graph[i][j]] + 1 > lh) {
                lh = glb[graph[i][j]] + 1;
            }
        }
        thisd = min(2ll, (long long)graph[i].size());
        if (diam < lh + rh || (diam == lh + rh && thisd > diamt)) {
            diam = lh + rh;
            diamt = thisd;
        }
//        cout << "for " << i << ' ' << lh << ' ' << rh << ' ' << lh + rh << ' ' << thisd << endl;
    }
//    cout << diam << endl;
//    cout << righth << ' ' << lefth << endl;
    long long ans = diamt * (m - 1) * max(righth, lefth) + diam + diamt * (m - 1) + 1;
//    ans = max(ans, righth + lefth )
    cout << ans << endl;
    return 0;
}
